// *******************************************************************
// Copyright (C) 2009 Telos Systems, TLS Corp.
// All rights reserved.
//
// No part of this source code or associated documentation may be 
// reproduced or utilized in any form or by any means, electronic or 
// mechanical, without permission in writing from TLS Corp.
// -------------------------------------------------------------------
//      File: APSend.h
// Description: See class description.
//    Author: Ioan L. Rus
//      Date: Nov 18, 2009
// Revisions: 
// -------------------------------------------------------------------
// INI Date        Description
// --- ----------- ---------------------------------------------------
// 
// *******************************************************************
#ifndef _IAPEVENTS_H_INCLUDED_
#define _IAPEVENTS_H_INCLUDED_

class IAPEvents  
{
public:
  virtual bool LoginResult(bool bResult)=0;

  // Enumerate events
  virtual bool EnumerateShowsCallback(const char *pszShowName,bool bRequiresPass,bool bIsActive,const char *pszHostName,bool bIsLast)=0;
  virtual bool EnumerateShowsForHostCallback(const char *pszShowName,bool bIsLast)=0;
  virtual bool EnumerateHostsCallback(const char *pszHostName,bool bIsLast)=0;
  virtual bool EnumerateDirectorsCallback(int nSession,const char *pszDirectorName,bool bIsTalent,bool bIsFree,bool bIsLast)=0;

  // Show connect event
  virtual bool SendShowInfo    (int nSession,int nMaxLines /* 12 or 24. less actual lines may be used */,int nHybrids)=0;

  // Attach events
  virtual bool SendMode        (int nSession,bool bTalent)=0;
  virtual bool SendShowChange  (int nSession,const char *pszNewShowName,const char *pszOldShowName)=0;

  virtual bool SendRecord      (int nSession,bool bOn)=0;
  virtual bool SendBusyAll     (int nSession,bool bOn)=0;
  virtual bool SendTransfer    (int nSession,bool bOn)=0;
  virtual bool SendMute        (int nSession,bool bOn)=0;
  virtual bool SendRingMute    (int nSession,bool bOn)=0;
  virtual bool SendDelayDump   (int nSession,bool bOn)=0;

  virtual bool SendHandset     (int nSession,bool bOn)=0;
  virtual bool SendSpeaker     (int nSession,bool bOn)=0;

  virtual bool SendLineState   (int nSession,int nLine,int nColumn,int nLineState,long lElapsedTimeSec)=0;

  virtual bool SendSeizeLine   (int nSession,int nLine,int nColumn)=0;
  virtual bool SendRingLine    (int nSession,const char *pszCallerId,int nLine)=0;
  virtual bool SendDropLine    (int nSession,const char *pszCallerId,int nLine)=0;
  virtual bool SendAnswerLine  (int nSession,const char *pszCallerId,int nLine,int nColumn)=0;
  virtual bool SendSelectLine  (int nSession,const char *pszCallerId,int nLine,int nColumn)=0;
  virtual bool SendDialKey     (int nSession,char chKey)=0;
  virtual bool SendText        (int nSession,int nTextType,const char *pszText,int nLine)=0;

  virtual bool SendError       (int nSession,int nErrorNumber,const char *pszErrorText)=0;
};

#endif // _IAPEVENTS_H_INCLUDED_
