// *******************************************************************
// Copyright (C) 2009 Telos Systems, TLS Corp.
// All rights reserved.
//
// No part of this source code or associated documentation may be 
// reproduced or utilized in any form or by any means, electronic or 
// mechanical, without permission in writing from TLS Corp.
// -------------------------------------------------------------------
//      File: APSend.h
// Description: See class description.
//    Author: Ioan L. Rus
//      Date: Nov 18, 2009
// Revisions: 
// -------------------------------------------------------------------
// INI Date        Description
// --- ----------- ---------------------------------------------------
// 
// *******************************************************************
#ifndef _IMESSAGETARGET_H_INCLUDED_
#define _IMESSAGETARGET_H_INCLUDED_

class CMsg2;

class IMessageTarget
{
public:
  // NOTE: The target receives ownership of the pMsg pointer! Make sure
  // to delete it when done!
  virtual bool OnConnectFailed(unsigned long nTransactionId) volatile =0;
  virtual bool OnConnectSuccess(unsigned long nTransactionId) volatile =0;
  virtual bool OnMessageReceived(const char *pData,unsigned cbData,unsigned long nTransactionId) volatile =0;
  virtual void OnSocketReadError(unsigned long nTransactionId) volatile =0;
  virtual void OnSocketWriteError(unsigned long nTransactionId) volatile =0;
  virtual void OnDataParseError(unsigned long nTransactionId) volatile =0;
};

#endif // _IMESSAGETARGET_H_INCLUDED_
